/*
 * BlueClientCanvas.java
 *
 * Created on September 14, 2006, 2:08 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package labThree;

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import java.lang.*;
import java.io.*;
import javax.bluetooth.*;

/**
 *
 * @author u0407749
 */
public class BlueClientCanvas extends GameCanvas implements CommandListener, Runnable {
    Sprite kenny;
    int kennyX, kennyY, flip, kennySpeed = 5;
    BlueClientTalker talker;
    String status = "";
    
    /** Creates a new instance of BlueClientCanvas */
    public BlueClientCanvas() {
        super(true);
    }
    
    void createSprites(){
        try{
            Image img = Image.createImage("/labThree/kenny.png");
            kenny = new Sprite(img, 69, 80);
            kenny.setPosition(0, 0);
            kenny.setRefPixelPosition(34, 40);
            kennyX = kennyY = 0;
            flip = 0;
        }
        catch(IOException io){
            System.err.println("kenny.png not found!");
            System.exit(-1);
        }
    }
    
    public void setStatus(String s){
        status = s;
    }
    
    public void run(){
        Graphics g = this.getGraphics();
        talker = new BlueClientTalker(this);
        Thread talkerThread = new Thread(talker);
        talkerThread.start();
        long start, stop, count, countStart;
        
        createSprites();
        
        int keyStates;
        //countStart = System.currentTimeMillis();
        //count = 0;
        while(true){
            start = System.currentTimeMillis();
            //count++;
            //System.err.println(System.currentTimeMillis());
            /*if(System.currentTimeMillis() - countStart >= 1000){
                setStatus("FPS: " + count);
            }
            else{
                count = 0;
                countStart = System.currentTimeMillis();
                setStatus("??");
            }*/
            
            keyStates = this.getKeyStates();
            
            if((keyStates & this.UP_PRESSED) != 0){
                kenny.move(0, -kennySpeed);
                kennyX = kenny.getX();
                kennyY = kenny.getY();
                talker.talk(kennyX, kennyY, flip);
            }
            else if((keyStates & this.DOWN_PRESSED) != 0){
                kenny.move(0, kennySpeed);
                kennyX = kenny.getX();
                kennyY = kenny.getY();
                talker.talk(kennyX, kennyY, flip);
            }
            else if((keyStates & this.LEFT_PRESSED) != 0){
                kenny.move(-kennySpeed, 0);
                kennyX = kenny.getX();
                kennyY = kenny.getY();
                talker.talk(kennyX, kennyY, flip);
            }
            else if((keyStates & this.RIGHT_PRESSED) != 0){
                kenny.move(kennySpeed, 0);
                kennyX = kenny.getX();
                kennyY = kenny.getY();
                talker.talk(kennyX, kennyY, flip);
            }
            else if((keyStates & this.FIRE_PRESSED) != 0){
                if(flip == 0){
                    kenny.setTransform(Sprite.TRANS_MIRROR);
                    flip = 1;
                }
                else{
                    flip = 0;
                    kenny.setTransform(Sprite.TRANS_NONE);
                }
                talker.talk(kennyX, kennyY, flip);
            }
            
            g.setColor(255, 255, 255);
            g.fillRect(0, 0, getWidth(), getHeight());
            g.setColor(0, 0, 0);
            g.drawString(status, 0, getHeight(), g.BOTTOM | g.LEFT);
            kenny.paint(g);
            this.flushGraphics();

            try{
                stop = System.currentTimeMillis();
                long x = stop - start;
                System.out.println(x);
                
                if(stop - start < 40){
                    Thread.sleep(40 - x);
                }
                System.out.println(System.currentTimeMillis() - stop);
            }
            catch(Exception e){
            }
        }
    }
    
    public void commandAction(Command c, Displayable d){
        
    }
    
}

class BlueClientTalker implements Runnable {
    LocalDevice local;
    StreamConnection conn;
    DataOutputStream out;
    BlueClientCanvas canvas;
    DiscoveryAgent agent;
    
    public BlueClientTalker(BlueClientCanvas canvas){
        this.canvas = canvas;
    }
    
    public void run(){
        try {
            // Make the local device discoverable for the
            // client to locate
            local = LocalDevice.getLocalDevice();
            agent = local.getDiscoveryAgent();
            
            // Create a client connection object to connect to server
            String connString = agent.selectService(
                new UUID("86b4d249fb8844d6a756ec265dd1f6a3", false),
                ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);
            
            if(connString != null){
                conn = (StreamConnection) Connector.open(connString);
                out = conn.openDataOutputStream();
            }
        } catch (BluetoothStateException e) {
            System.err.println("BluetoothStateException: ");
            System.err.println(e.getMessage());
        } catch (IOException e) {
            System.err.println("IOException: ");
            System.err.println(e.getMessage());
        }
    }
    
    public void talk(int x, int y, int flip){
        try{
            out.writeInt(x);
            out.writeInt(y);
            out.writeInt(flip);
        }
        catch(IOException io){
            System.err.println("Failed to send coordinates to server");
        }
    }
    
    public void close(){
        try{
            out.close();
            conn.close();
        }
        catch(IOException io){
            System.err.println("Failed to close connections to server");
        }
    }
}