/*
 * BlueServerCanvas.java
 *
 * Created on September 14, 2006, 2:08 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package labThree;

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import java.lang.*;
import java.io.*;
import javax.bluetooth.*;

/**
 *
 * @author u0407749
 */
public class BlueServerCanvas extends GameCanvas implements CommandListener, Runnable {
    Sprite kenny;
    int kennyX, kennyY, flip;
    String status = "";
    
    public BlueServerCanvas() {
        super(true);
    }
    
    void createSprites(){
        try{
            Image img = Image.createImage("/labThree/kenny.png");
            kenny = new Sprite(img, 69, 80);
            kenny.setPosition(0, 0);
            kenny.setRefPixelPosition(34, 40);
            kennyX = kennyY = 0;
            flip = 0;
        }
        catch(IOException io){
            System.err.println("kenny.png not found!");
            System.exit(-1);
        }
    }
    
    public void setStatus(String s){
        status = s;
    }
    
    public void setKenny(int x, int y, int flip){
        kennyX = x;
        kennyY = y;
        kenny.setPosition(x, y);
        if(flip == 1){
            kenny.setTransform(Sprite.TRANS_MIRROR);            
        }
        else{
            kenny.setTransform(Sprite.TRANS_NONE);
        }
    }
        
    public void run(){
        Graphics g = this.getGraphics();
        Thread listenerThread = new Thread(new BlueServerListener(this));
        listenerThread.start();
        
        createSprites();
        
        while(true){
            g.setColor(255, 255, 255);
            g.fillRect(0, 0, getWidth(), getHeight());
            kenny.paint(g);
            g.setColor(0, 0, 0);
            g.drawString(status, 0, getHeight(), g.BOTTOM | g.LEFT);
            this.flushGraphics();
            
            try{
                Thread.sleep(80);
            }
            catch(Exception e){
            }
        }
    }
    
    public void commandAction(Command c, Displayable d){
        
    }
    
}

class BlueServerListener implements Runnable {
    LocalDevice local;
    StreamConnectionNotifier notifier;
    StreamConnection conn;
    DataInputStream in;
    BlueServerCanvas canvas;
    
    public BlueServerListener(BlueServerCanvas canvas){
        this.canvas = canvas;
    }
    
    public void run(){
        try {
            // Make the local device discoverable for the
            // client to locate
            local = LocalDevice.getLocalDevice();
            if (!local.setDiscoverable(DiscoveryAgent.GIAC)) {
                canvas.setStatus("Failed to change to the " +
                        "discoverable mode");
                return;
            }
            
            // Create a server connection object to accept
            // a connection from a client
            notifier = (StreamConnectionNotifier)
                    Connector.open("btspp://localhost:" +
                    "86b4d249fb8844d6a756ec265dd1f6a3");
            
            canvas.setStatus("Port open and waiting");
            
            while(true){
                // Accept a connection from the client
                conn = notifier.acceptAndOpen();
                canvas.setStatus("Incoming client connected");
                // Open the input to read data from
                in = conn.openDataInputStream();

                int data1, data2, flip;
                try{
                    while (true) {
                        data1 = in.readInt();
                        data2 = in.readInt();
                        flip = in.readInt();
                        
                        canvas.setKenny(data1, data2, flip);
                    }
                }
                catch(Exception e){
                    canvas.setStatus("Client left");
                    in.close();
                    conn.close();
                }
            }
            
            /*in.close();
            conn.close();
            notifier.close();*/
        } catch (BluetoothStateException e) {
            System.err.println("BluetoothStateException: ");
            System.err.println(e.getMessage());
        } catch (IOException e) {
            System.err.println("IOException: ");
            System.err.println(e.getMessage());
        }
    }   
}